// Arduino UNO, BLE module CH9141, LED, Mit App Inventor
// Created by Benqo 2024-12-07

// Connect the CH9141 TX to the Arduino RX on pin 2.
// Connect the CH9141 RX to the Arduino TX on pin 3 through 1k resistor and to ground through 2k resistor (voltage divider).

// Mit App Inventor sends 2 bytes:
// command byte | value byte
//   reading2   |  reading1
//   0000 0001  |  0000 000x  = 256 + x    LEDstate         command: 1   x: 0 or 1
//   0000 0010  |  xxxx xxxx  = 512 + x    SliderPosition   command: 2   x: 0 to 255


#include <SoftwareSerial.h>
SoftwareSerial BTserial(2, 3);  // RX | TX

#define LEDpin 8
byte reading1, reading2;

unsigned long currentTime;
unsigned long lastTime;
unsigned long interval = 1000;  // milliseconds

int value = 0;

void setup() {
  pinMode(LEDpin, OUTPUT);
  digitalWrite(LEDpin, 0);

  Serial.begin(9600);
  Serial.println("Waiting for incomming data from CH9141BLE2U");
  BTserial.begin(9600);

  delay(500);
}

void loop() {

  currentTime = millis();

  // send something to the APP every 1 second
  if (currentTime - lastTime >= interval) {
    BTserial.print(value+100);
    BTserial.print(",");
    BTserial.println(value);
    value++;
    lastTime += interval;
  }

  // Keep reading from CH9141
  if (BTserial.available() > 1) {
    reading1 = BTserial.read();  // value byte
    reading2 = BTserial.read();  // command byte
    delay(1);

    // Display received bytes on the Serial Monitor
    Serial.print(reading1);
    Serial.print("\t");
    Serial.println(reading2);

    switch (reading1) {
      case 1:  // toggle the LED
        digitalWrite(LEDpin, reading2);
        break;
      default:
        break;
    }
  }
}
